<?php
/*
 * ----------------------------------------------------------------------------------
 * Author:	Spyker
 * Version:	1.1
 * Date:	2011-03-15
 * Copyright:	for free
 * 
 * System:	xaseco/1.06 and up
 *
 * manialink = 909001   widget team list of players on current round
 * manialink = 909902	widget scores in progress
 * manialink = 909003	widget player panel score finish
 * manialink = 909004	widge infos config server
 * manialink = 909005	widget small scores in progress begin round
 * manialink = 909006	widget small scores in progress end round
 * -----------------------------------------------------------------------------------
 *
 *Replacement for the black rounds finish panel .. like plugin nicofinish with specialies screens on team mod
 *Dependency -> sykescore.xml									    					 
 */

Aseco::registerEvent('onSync', 'spyke_start');
Aseco::registerEvent('onStartup', 'spyke_startupcustom');

Aseco::registerEvent('onPlayerConnect', 'score_affich');
Aseco::registerEvent('onPlayerConnect', 'small_score_affich');
//Aseco::registerEvent('onPlayerConnect', 'show_widget_team_list');

Aseco::registerEvent('onNewChallenge', 'score_finish_clear');
Aseco::registerEvent('onNewChallenge', 'round_point_conf');

Aseco::registerEvent('onBeginRound', 'reset_manialink_begin_round');
Aseco::registerEvent('onBeginRound', 'round_point_conf');
Aseco::registerEvent('onBeginRound', 'small_score_affich');
//Aseco::registerEvent('onBeginRound', 'score_affich');

Aseco::registerEvent('onPlayerFinish', 'match_finish');
Aseco::registerEvent('onPlayerFinish', 'spyke_store_time');

Aseco::registerEvent('onEndRound', 'reset_manialink_end_round');
Aseco::registerEvent('onEndRound', 'score_finish');
//Aseco::registerEvent('onEndRound', 'score_affich');
Aseco::registerEvent('onEndRound', 'small_score_affich');

Aseco::registerEvent('onMenuLoaded', 'spyke_Menu');
Aseco::registerEvent('onMenuLoaded', 'spyke_right');

Aseco::registerEvent('onEverySecond', 'show_small_widget_score');
Aseco::registerEvent('onEverySecond', 'show_widget_score');
Aseco::registerEvent('onEverySecond', 'show_widget_team');
Aseco::registerEvent('onEverySecond', 'show_widget_infos');
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'spyke_forceteam');
Aseco::addChatCommand('spk', '/spk');

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function spyke_start($aseco, $command) //spyke_start
{
global $score, $rights, $plfinishmax, $rposx, $rposy, $srposx, $srposy, $esrposx, $esrposy, $tposx, $tposy, $iposx, $iposy, $pposx, $pposy, $spyke_conf;
$score["RoundBlue"]="0";
$score["RoundRed"]="0";
$score["SetBlue"]="0";
$score["SetRed"]="0";
$score["BluePoints"]="0";
$score["RedPoints"]="0";
$score["EndRoundBlue"]="0";
$score["EndRoundRed"]="0";
$score["Challenges"]="1";
if (!$spyke_conf = $aseco->xml_parser->parseXML('spykescore.xml')) 
	{
		trigger_error("[plugin.spykescore.php] Could not read/parse config file spykescore.xml !", E_USER_ERROR);
	}else{}
$conf = simplexml_load_file('spykescore.xml');
$plfinishmax = $conf->player->max;
$rights = $conf->perm->rights;
$rposx = $conf->records->records_posx;
$rposy = $conf->records->records_posy;
$srposx = $conf->small_records->small_records_posx;
$srposy = $conf->small_records->small_records_posy;
$esrposx = $conf->small_records->end_small_records_posx;
$esrposy = $conf->small_records->end_small_records_posy;
$tposx = $conf->teamlist->team_posx;
$tposy = $conf->teamlist->team_posy;
$pposx = $conf->panel->panel_posx;
$pposy = $conf->panel->panel_posy;
$iposx = $conf->infos->info_posx;
$iposy = $conf->infos->info_posy;
$aseco->addCall('NextChallenge');
}

//////////////////////////////////////////////////////////////////////////////////////////
   function spyke_startupcustom()
	{
	setCustomUIField('round_scores', false);   
	}

//////////////////////////////////////////////////////////////////////////////////////////
function spyke_store_time($aseco, $finish_item) {
   global $round_times;
   global $round_finishes;
      
   if (($aseco->server->gameinfo->mode == 0 ||
        $aseco->server->gameinfo->mode == 2 ||
        $aseco->server->gameinfo->mode == 5) && $finish_item->score > 0) {
      $round_times[$finish_item->player->login] = $finish_item->score;
      $round_finishes++;
}
}  

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function show_widget_team($aseco) //
{
create_widget_team_list($aseco);
}

function show_widget_infos($aseco) //
{
create_widget_infos($aseco);
}

function show_widget_score($aseco) //
{
create_widget_score($aseco);
}

function show_small_widget_score($aseco) //
{
create_widget_small_score($aseco);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function reset_manialink_begin_round($aseco, $commmand)
{
global $spyke_conf, $showrecords, $showsmallrecords, $xmlsscoreend, $xmlscore, $xmlsscore, $team, $infos, $showendsmallrecords;
if ($aseco->server->gameinfo->mode == 2)
{
$conf = simplexml_load_file('spykescore.xml');
$showrecords = $conf->records->show;
$showsmallrecords = $conf->small_records->show;
$team['show_team_list'] = $conf->teamlist->show;
$infos['show_infos'] = $conf->infos->show;
$showendsmallrecords  = "false";

$xmlsscoreend = '<manialink id="909006"></manialink>';
$aseco->client->addCall("SendDisplayManialinkPage", array($xmlsscoreend, 1, false));

create_widget_team_list($aseco);
create_widget_infos($aseco);
create_widget_score($aseco);
create_widget_small_score($aseco);
}
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function reset_manialink_end_round($aseco, $commmand)
{
global $spyke_conf, $showrecords, $showendsmallrecords, $xmlscore, $xmlsscore, $xmlsscoreend, $team, $infos, $showsmallrecords;
if ($aseco->server->gameinfo->mode == 2)
{
$conf = simplexml_load_file('spykescore.xml');
$showrecords = $conf->records->show_end_round;
$showendsmallrecords = $conf->small_records->show_end_round;
$team['show_team_list'] = $conf->teamlist->show_end_round;
$infos['show_infos'] = $conf->infos->show_end_round;
$showsmallrecords = "false";

$xmlsscore = '<manialink id="909005"></manialink>';
$aseco->client->addCall("SendDisplayManialinkPage", array($xmlsscore, 1, false));
$xml = '<manialink id="909003"></manialink>';
$aseco->client->query("SendDisplayManialinkPage", $xml, 1, false);

create_widget_team_list($aseco);
create_widget_infos($aseco);
create_widget_score($aseco);
create_widget_small_score($aseco);
}
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function match_finish($aseco, $finish_item) 
{

global $round_times, $rpointsspyke, $score, $countIDRIDB, $rules, $round_finishes;

$aposy = -1;   
$sposy = -0.2;
$plfinish = 0;
$strip = "$n";
$bluescore = 0;
$redscore = 0;
$count = $countIDRIDB;
$conf = simplexml_load_file('spykescore.xml');
$pposx = $conf->panel->panel_posx;
$pposy = $conf->panel->panel_posy;
$plfinishmax = $conf->player->max;
if($plfinishmax=="0" || $plfinishmax=="" || $plfinishmax>12)
{$plfinishmax=12;}else{}

$xml .= '<manialink id="909003">';
$xml .= '<frame posn="'. $pposx .' '. $pposy .' 0">';

	foreach ($round_times as $key => $row) 
    	{
   	$BestTime[$key]  = $row['BestTime'];
   	$NickName[$key] = $row['NickName'];
    	}
	if (is_array($BestTime)) 
   	{
   	array_multisort($BestTime, SORT_ASC, $round_times);
   	}
	foreach($round_times as $pl => $tm)
	{
          if ($player = $aseco->server->players->getPlayer($pl))
		$nick = $player->nickname;
          	else  
          	$nick = $pl;
          	$new = false;
		$aseco->client->query('GetPlayerInfo',$pl);
		$playerId = $aseco->client->getResponse();
		$PlayerTeamId = $playerId['TeamId'];
		$namestriped = str_replace($strip, "", $nick);
		$plfinish++; $sposy--; $sposy--; $sposy--; $aposy--; $aposy--; $aposy--;

		if ($aseco->server->gameinfo->mode == 2)
		{   	
		if($PlayerTeamId==0)
		{ 
		if($rules=="ON")
		{
		$bluescore=$bluescore+$count;
		if ($plfinish <= $plfinishmax)
		{   
		$xml .= '<format textsize="1"/><label posn="-19.3 ' . $sposy. ' 1.5" sizen="30 3 2" scale="0.3" style="TextRaceChrono" halign="center" text="$s$0f0+'. $count .' "/>';
		$xml .= '<format textsize="1"/><label posn="-27.5 ' . $sposy . ' 1.5" sizen="30 3 2" halign="left" scale="0.3" style="TextRaceChrono" text="$s$fff'.formatTime($tm).' "/>';   
      		$xml .= '<format textsize="1.7"/><label posn="-16.8 ' . $sposy . ' 1.6" sizen="12 3 2" halign="left" text="$000' . $namestriped . ' "/>';		
		$xml .= '<quad sizen="5.8 2.1" posn="-24.5 ' . $aposy . ' 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleBlue"/>';
      		$xml .= '<quad sizen="27.8 3" posn="-28.3 ' . $aposy . ' 1.1"  valign="center" halign="left" style="Bgs1InRace" substyle="NavButton"/>';
		$xml .= '<quad sizen="21.2 2.1" posn="-21.60 ' . $aposy . ' 1.1"  valign="center" halign="left" style="BgRaceScore2" substyle="BgScores"/>';
		}else{}
		$count=$count-1;
		}else
		{
		$bluescore=$bluescore+$rpointsspyke[$plfinish-1];
		if ($plfinish <= $plfinishmax)
		{ 
		$xml .= '<format textsize="1"/><label posn="-19.3 ' . $sposy. ' 1.5" sizen="30 3 2" scale="0.3" style="TextRaceChrono" halign="center" text="$s$0f0+'.$rpointsspyke[$plfinish-1] .' "/>';		
		$xml .= '<format textsize="1"/><label posn="-27.5 ' . $sposy . ' 1.5" sizen="30 3 2" halign="left" scale="0.3" style="TextRaceChrono" text="$s$fff'.formatTime($tm).' "/>';   
      		$xml .= '<format textsize="1.7"/><label posn="-16.5 ' . $sposy . ' 1.6" sizen="12 3 2" halign="left" text="$000' . $namestriped . ' "/>';		
		$xml .= '<quad sizen="5.8 2.1" posn="-24.5 ' . $aposy . ' 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleBlue"/>';
      		$xml .= '<quad sizen="27.8 3" posn="-28.3 ' . $aposy . ' 1.1"  valign="center" halign="left" style="Bgs1InRace" substyle="NavButton"/>';
		$xml .= '<quad sizen="21.2 2.1" posn="-21.6 ' . $aposy . ' 1.1"  valign="center" halign="left" style="BgRaceScore2" substyle="BgScores"/>';
 		}else{}
		}
		}
		
		elseif($PlayerTeamId==1)
		{
		if($rules=="ON")
		{
		$redscore=$redscore+$count;
		if ($plfinish <= $plfinishmax)
		{ 
		$xml .= '<format textsize="1"/><label posn="-19.3 ' . $sposy. ' 1.5" sizen="30 3 2" scale="0.3" style="TextRaceChrono" halign="center" text="$s$0f0+'. $count .' "/>';		
		$xml .= '<format textsize="1"/><label posn="-27.5 ' . $sposy . ' 1.5" sizen="30 3 2" halign="left" scale="0.3" style="TextRaceChrono" text="$s$fff'.formatTime($tm).' "/>';   
      		$xml .= '<format textsize="1.7"/><label posn="-16.5 ' . $sposy . ' 1.6" sizen="12 3 2" halign="left" text="$000' . $namestriped . ' "/>';		
		$xml .= '<quad sizen="5.8 2.1" posn="-24.5 ' . $aposy . ' 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleRed"/>';
      		$xml .= '<quad sizen="27.8 3" posn="-28.3 ' . $aposy . ' 1.1"  valign="center" halign="left" style="Bgs1InRace" substyle="NavButton"/>';
		$xml .= '<quad sizen="21.2 2.1" posn="-21.60 ' . $aposy . ' 1.1"  valign="center" halign="left" style="BgRaceScore2" substyle="BgScores"/>';
		}else{}
		$count=$count-1;
		}
		else
		{
		$redscore = $redscore+$rpointsspyke[$plfinish-1];
		if ($plfinish <= $plfinishmax) 
		{
		$xml .= '<format textsize="1"/><label posn="-19.3 ' . $sposy. ' 1.5" sizen="30 3 2" scale="0.3" style="TextRaceChrono" halign="center" text="$s$0f0+'.$rpointsspyke[$plfinish-1] .' "/>';
		$xml .= '<format textsize="1"/><label posn="-27.5 ' . $sposy . ' 1.5" sizen="30 3 2" halign="left" scale="0.3" style="TextRaceChrono" text="$s$fff'.formatTime($tm).' "/>';   
      		$xml .= '<format textsize="1.7"/><label posn="-16.5 ' . $sposy . ' 1.6" sizen="12 3 2" halign="left" text="$000' . $namestriped . ' "/>';		
		$xml .= '<quad sizen="5.8 2.1" posn="-24.5 ' . $aposy . ' 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleRed"/>';
      		$xml .= '<quad sizen="27.8 3" posn="-28.3 ' . $aposy . ' 1.1"  valign="center" halign="left" style="Bgs1InRace" substyle="NavButton"/>';
		$xml .= '<quad sizen="21.2 2.1" posn="-21.6 ' . $aposy . ' 1.1"  valign="center" halign="left" style="BgRaceScore2" substyle="BgScores"/>';
		}else{}
		}
		}
		
		}elseif ($aseco->server->gameinfo->mode == 0 || $aseco->server->gameinfo->mode == 5 || $aseco->server->gameinfo->mode == 1) 
		{
	  	$xml .= '<format textsize="1"/><label posn="-19.3 ' . $sposy. ' 1.5" sizen="30 3 2" scale="0.3" style="TextRaceChrono" halign="center" text="$s$0f0+'.$rpointsspyke[$plfinish-1] .' "/>';
      		$xml .= '<format textsize="1"/><label posn="-27.5 ' . $sposy . ' 1.5" sizen="30 3 2" halign="left" scale="0.3" style="TextRaceChrono" text="$s$fff'.formatTime($tm).' "/>';   
      		$xml .= '<format textsize="1.7"/><label posn="-16.5 ' . $sposy . ' 1.6" sizen="12 3 2" halign="left" text="$000' . $namestriped . ' "/>';

      		$xml .= '<quad sizen="4 3" posn="-19.6 ' . $aposy . ' 1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton" />';
      		$xml .= '<quad sizen="6.2 3" posn="-24.9 ' . $aposy . ' 1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton" />';
      		$xml .= '<quad sizen="17 3" posn="-17.4 ' . $aposy . ' 1.1"  valign="center" halign="left" style="Bgs1InRace" substyle="NavButton"/>';
		}
	}
$score["EndRoundBlue"]=$bluescore;
$score["EndRoundRed"]=$redscore;

$xml .= '</frame>';
$xml .= '</manialink>';
$aseco->client->query("SendDisplayManialinkPage", $xml, 3000, false);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function create_widget_Team_list($aseco)
{
global $player, $score, $countIDRIDB, $tposx, $tposy, $spyke_conf, $CH, $team;

if ($aseco->server->gameinfo->mode == 2)
{
if($team['show_team_list'] == "false")
{
$countIDR = 0;
$countIDB = 0;
foreach ($aseco->server->players->player_list as &$player) 
		{
		$login = $player->login;
		$nickname = $player->nickname;
		$aseco->client->query('GetPlayerInfo',"$login");
		$playerid = $aseco->client->getResponse(); 
      		$ID = $playerid['TeamId'];
		$namestriped = str_replace($strip, "", $nickname);
       	if ($player->isspectator == 0)
			{
			if ($ID==0){$countIDB++;}
			else{$countIDR++;}
			$countIDRIDB=$countIDB+$countIDR;				
			}
		}
$xmlteam = '<manialinks><manialink id="909001"></manialink></manialinks>';	
$aseco->client->query("SendDisplayManialinkPage", $xmlteam, 0, false);
}else{

	$hightB = 3;
	$hightR = 3;
	$posyB = -2.7;
	$posyR = -2.7;
	$posyBN = -2.9;
	$posyRN = -2.9;
	$linkposy = $tposy-21;
	$CH = $score["Challenges"];
	$countIDR = 0;
	$countIDB = 0;
$conf = simplexml_load_file('spykescore.xml');
$tposx = $conf->teamlist->team_posx;
$tposy = $conf->teamlist->team_posy;
	
$xmlteam .= '<manialinks><manialink id="909001">';
	$xmlteam .= '<frame posn="'. $tposx .'  '. $tposy .' 0 ">';
	$xmlteam .= '<quad sizen="12 2" posn="0 -0.5 0" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlteam .= '<label textsize="1" scale="1" sizen="0 0 0" posn="1.25 -0.7 0" halign="left" text="$s$00fBlue $fffTeam"/>';
	$xmlteam .= '</frame>'; 	

	$xmlteam .= '<frame posn="'. $tposx .' '. $linkposy .' 0 ">';
	$xmlteam .= '<quad sizen="12 2" posn="0 -0.5 0" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlteam .= '<label textsize="1" scale="1" sizen="0 0 0" posn="1.25 -0.7 0" halign="left" text="$s$f00Red $fffTeam"/>';

	$xmlteam .= '</frame>';

	foreach ($aseco->server->players->player_list as &$player) 
		{
		$login = $player->login;
		$nickname = $player->nickname;
		$aseco->client->query('GetPlayerInfo',"$login");
		$playerid = $aseco->client->getResponse(); 
      		$ID = $playerid['TeamId'];
		$namestriped = str_replace($strip, "", $nickname);

       	if ($player->isspectator == 0)
		{
		if ($ID==0){$countIDB++;}
		else{$countIDR++;}

			if ($ID==0 && $countIDB<=8 )
			{
			$xmlteam .= '<frame posn="'. $tposx .' '. $tposy .' 0 ">';
			$xmlteam .= '<quad sizen="17.8 2" posn="0.6 ' . $posyB . ' 0" style="BgsPlayerCard" substyle="BgCard"/>';
	
			$xmlteam .= '<label textsize="1" scale="0.8" sizen="16.5 2" posn="1.25 ' . $posyBN . ' 0" text=" '.$namestriped.' "/>';
			$xmlteam .= '</frame>'; 
			$posyB= $posyB-1.95;
			$posyBN=$posyBN-1.95;
			}
			elseif ($ID==1 && $countIDR<=8)
			{
			$xmlteam .= '<frame posn="'. $tposx .' '. $linkposy .' 0 ">';
			$xmlteam .= '<quad sizen="17.8 2" posn="0.6 ' . $posyR . ' 0" style="BgsPlayerCard" substyle="BgCard"/>';
	
			$xmlteam .= '<label textsize="1" scale="0.8" sizen="16.5 2" posn="1.25 ' . $posyRN . ' 0"  text=" '.$namestriped.' "/>';
			$xmlteam .= '</frame>'; 
			$posyR=$posyR-1.95;
			$posyRN=$posyRN-1.95;		
			}else{}

		}else{}

		$countIDRIDB=$countIDB+$countIDR;				
		}

	if($countIDR>0 && $countIDR<=8)
	{
	$hightR=$hightR+(2*($countIDR-1));
	$xmlteam .= '<frame posn="'.$tposx.' '. $linkposy .' 0 ">';
	$xmlteam .= '<quad sizen="19 ' .$hightR. '" posn="0 -2.2 0" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlteam .= '<label textsize="1" scale="1" sizen="0 0 0" posn="9.25 -0.7 0" halign="left" text="$s$fff'.$countIDR.'"/>';
	$xmlteam .= '</frame>';
	}else{}
	if($countIDB>0 && $countIDB<=8)
	{
	$hightB=$hightB+(2*($countIDB-1));
	$xmlteam .= '<frame posn="'.$tposx.' '. $tposy .' 0 ">';
	$xmlteam .= '<quad sizen="19 ' .$hightB. '" posn="0 -2.2 0" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlteam .= '<label textsize="1" scale="1" sizen="0 0 0" posn="9.25 -0.7 0" halign="left" text="$s$fff'.$countIDB.'"/>';
	$xmlteam .= '</frame>';
	}else{}
$xmlteam .= '</manialink></manialinks>';
$aseco->client->query("SendDisplayManialinkPage", $xmlteam, 0, false);
}
}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function create_widget_infos($aseco)
{
global $rpointsspyke, $spyke_conf, $rules, $infos, $score;

if ($aseco->server->gameinfo->mode == 2)
{
if($infos['show_infos'] == "false")
{
$xmlinfos = '<manialink id="909004"></manialink>';	
$aseco->client->query("SendDisplayManialinkPage", $xmlinfos, 0, false);
}else{

$conf = simplexml_load_file('spykescore.xml');
$iposx = $conf->infos->info_posx;
$iposy = $conf->infos->info_posy;
$aseco->client->query('GetUseNewRulesTeam',array());
$newrules = $aseco->client->getresponse();
$CH = $score["Challenges"];
if($newrules['CurrentValue']=="1")
	{
	$rules="ON";
	$max=$countIDRIDB;
	$mod="Team";
	$custom="OFF";
	}else{
		$rules="OFF";
		if($rpointsspyke[0]==""){$max="wait";}
		else{$max = $rpointsspyke[0];}
      		$mod="System";
		$custom="ON";
		}
$aseco->client->query('GetTeamPointsLimit');
$TPL=$aseco->client->getResponse();
$TPL = $TPL['CurrentValue'];

$xmlinfos .= '<manialink id="909004">';
	$xmlinfos .= '<frame posn="'. $iposx .' '.$iposy .' 0">';
	$xmlinfos .= '<quad sizen="12 2" posn="0 -0.5 0" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlinfos .= '<format textsize="1"/><label posn="1.25 -0.7 0" sizen="15 3 2" scale="1" halign="left" text="$s$fffMatch Conf"/>';
	$xmlinfos .= '<quad sizen="20 7.1" posn="0 -5.7 1.1"  valign="center" halign="left" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlinfos .= '<quad sizen="9.4 2.2"  posn="10 -2.6 0.002" style="BgsPlayerCard" substyle="BgCard"/>';
	$xmlinfos .= '<quad sizen="9.2 2.2"  posn="0.6 -2.6 0.002" style="BgsPlayerCard" substyle="BgCard"/>';
	$xmlinfos .= '<format textsize="1"/><label posn="1.5 -2.9 1.5" sizen="10 3 2" scale="1" halign="left" text="$s$fffRounds :$0ff  '.$TPL.' "/>';
	$xmlinfos .= '<format textsize="1"/><label posn="11.3 -2.9 1.5" sizen="10 3 2" scale="1" halign="left" text="$s$fffSets :$0ff  '.$CH.' "/>';
	$xmlinfos .= '<format textsize="1"/><label posn="0.9 -5 1.5" sizen="10 3 2" scale="1" halign="left" text="$s$fffMax Points$6c0  '.$max.' "/>';
	$xmlinfos .= '<format textsize="1"/><label posn="10.8 -5 1.5" sizen="10 3 2" scale="1" halign="left" text="$s$fffMode$6c0  '.$mod.' "/>';
	$xmlinfos .= '<format textsize="1"/><label posn="0.9 -7.1 1.5" sizen="9 3 2" scale="1" halign="left" text="$s$fffNew Rules$6c0  '.$rules.' "/>';
	$xmlinfos .= '<format textsize="1"/><label posn="10.7 -7.1 1.5" sizen="8.7 3 2" scale="1" halign="left" text="$s$fffCustom Pts$6c0  '.$custom.'"/>';
	$xmlinfos .= '</frame>';
$xmlinfos .= '</manialink>';	
$aseco->client->query("SendDisplayManialinkPage", $xmlinfos, 0, false);
}
}
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function score_finish($aseco,$command) //score_update and reset manialink on en round
{
global $score, $ERB, $ERR, $TPL;
if ($aseco->server->gameinfo->mode == 2)
{
$RB = $score["RoundBlue"];
$RR = $score["RoundRed"];
$SB = $score["SetBlue"];
$SR = $score["SetRed"];
$BP = $score["BluePoints"];
$RP = $score["RedPoints"];
$CH = $score["Challenges"];
$ERB = $score["EndRoundBlue"];
$ERR = $score["EndRoundRed"];
$aseco->client->query('GetTeamPointsLimit');
$TPL=$aseco->client->getResponse();
$TPL = $TPL['NextValue'];
	if($ERB>$ERR)
	{$RB++;$BP++;}
	elseif($ERR>$ERB)
	{$RR++;$RP++;}
	else{}
	if($RB==$TPL || $RR==$TPL)
	{
	if($RB>$RR)
	{$SB++;}
	else{$SR++;}
	}else{}
$score["SetBlue"] = $SB;
$score["SetRed"] = $SR;
$score["RoundBlue"] = $RB;
$score["RoundRed"] = $RR;
$score["EndRoundBlue"] = "0";
$score["EndRoundRed"] = "0";
$score["BluePoints"] = $BP;
$score["RedPoints"] = $RP;
$SBR=$SB+$SR;
}else{}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function create_widget_score($aseco) 
{
global $score, $ERB, $ERR, $rpointsspyke, $spyke_conf, $showrecords, $xmlscore;
if ($aseco->server->gameinfo->mode == 2)
{
if($showrecords == "false")
{
$xmlscore = '<manialink id="909002"></manialink>';	
$aseco->client->query("SendDisplayManialinkPage", $xmlscore, 0, false);
}else{
$RB = $score["RoundBlue"];
$RR = $score["RoundRed"];
$SB = $score["SetBlue"];
$SR = $score["SetRed"];
$BP = $score["BluePoints"];
$RP = $score["RedPoints"];
$CH = $score["Challenges"];
$aseco->client->query('GetTeamPointsLimit');
$TPL=$aseco->client->getResponse();
$TPL = $TPL['NextValue'];
$conf = simplexml_load_file('spykescore.xml');
$rposx = $conf->records->records_posx;
$rposy = $conf->records->records_posy;

$xmlscore = '<manialink id="909002">';
	$xmlscore .= '<frame posn="'. $rposx .' '. $rposy .' 0">';
	
	$xmlscore .= '<quad sizen="12 2" posn="-17 4.9 1.1"  valign="center" halign="left" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-15 5.7 1.5" sizen="15 3 2" scale="1" halign="left" text="$s$fffLast Round"/>';
	
	$xmlscore .= '<quad sizen="20 3.2" posn="-15 2.6 1.1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlscore .= '<quad sizen="6.4 2.2" posn="-21.1 2.6 1.1"  valign="center" halign="center" style="BgsPlayerCard" substyle="BgCard"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-21.2 3.4 1.5" sizen="6 3 2" scale="1" halign="center" text="$s$fffTeam Pts"/>';
	$xmlscore .= '<quad sizen="4 2.2" posn="-7.7 2.6 1.1"  valign="center" halign="center" style="BgRaceScore2" substyle="BgScores"/>';
	$xmlscore .= '<quad sizen="4 2.2" posn="-13.7 2.6 1.1"  valign="center" halign="center" style="BgRaceScore2" substyle="BgScores"/>';
	$xmlscore .= '<quad sizen="2 2.2" posn="-16.7 2.6 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleBlue"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-13.5 3.2 1.5" sizen="6 3 2" scale="1" halign="center" text="$s$0ff'.$ERB.'"/>';
	$xmlscore .= '<quad sizen="2 2.2" posn="-10.7 2.6 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleRed"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-7.4 3.2 1.5" sizen="6 3 2" scale="1" halign="center" text="$s$0ff'.$ERR.'"/>';

	$xmlscore .= '<quad sizen="12 2" posn="-17 0.3 1.1"  valign="center" halign="left" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-15 1.1 1.5" sizen="15 3 2" scale="1" halign="left" text="$s$fffRounds Scores"/>';

	$xmlscore .= '<quad sizen="2.2 2.7" posn="-26.6 -0.7 0.2" style="Icons64x64_1" substyle="ArrowGreen"/>';
	$xmlscore .= '<quad sizen="20 5.6" posn="-15 -3.2 1.1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlscore .= '<quad sizen="6.4 2.2" posn="-21.1 -2 1.1"  valign="center" halign="center" style="BgsPlayerCard" substyle="BgCard"/>';
	$xmlscore .= '<quad sizen="2 2.2" posn="-16.7 -2 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleBlue"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-21.2 -1.2 1.5" sizen="6 3 2" scale="1" halign="center" text="$s$fffCurrent"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-13.5 -1.4 1.5" sizen="6 3 2" scale="1" halign="center" text="$s$0ff'.$RB.'/'.$TPL.'"/>';
	$xmlscore .= '<quad sizen="4 2.2" posn="-7.7 -2 1.1"  valign="center" halign="center" style="BgRaceScore2" substyle="BgScores"/>';
	$xmlscore .= '<quad sizen="4 2.2" posn="-13.7 -2 1.1"  valign="center" halign="center" style="BgRaceScore2" substyle="BgScores"/>';
	$xmlscore .= '<quad sizen="2 2.2" posn="-10.7 -2 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleRed"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-7.4 -1.4 1.5" sizen="6 3 2" scale="1"  halign="center" text="$s$0ff'.$RR.'/'.$TPL.' "/>';

	$xmlscore .= '<quad sizen="6.4 2.2" posn="-21.1 -4.4 1.1"  valign="center" halign="center" style="BgsPlayerCard" substyle="BgCard"/>';
	$xmlscore .= '<quad sizen="2 2.2" posn="-16.7 -4.4 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleBlue"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-21.2 -3.7 1.5" sizen="6 3 2" scale="1" halign="center" text="$s$fffGlobal"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-13.5 -3.7 1.5" sizen="6 3 2" scale="1" halign="center" text="$s$6c0'.$BP.'"/>';
	$xmlscore .= '<quad sizen="4 2.2" posn="-7.7 -4.4 1.1"  valign="center" halign="center" style="BgRaceScore2" substyle="BgScores"/>';
	$xmlscore .= '<quad sizen="4 2.2" posn="-13.7 -4.4 1.1"  valign="center" halign="center" style="BgRaceScore2" substyle="BgScores"/>';
	$xmlscore .= '<quad sizen="2 2.2" posn="-10.7 -4.4"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleRed"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-7.4 -3.7 1.5" sizen="6 3 2" scale="1"  halign="center" text="$s$6c0'.$RP.'"/>';

	$xmlscore .= '<quad sizen="12 2" posn="-17 -6.7 1.1"  valign="center" halign="left" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-15 -5.9 1.5" sizen="15 3 2" scale="1" halign="left" text="$s$fffSets Scores"/>';
	
	$xmlscore .= '<quad sizen="2.2 2.7" posn="-26.6 -7.6 0.2" style="Icons64x64_1" substyle="ArrowGreen"/>';
	$xmlscore .= '<quad sizen="20 3.2" posn="-15 -9 1.1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlscore .= '<quad sizen="6.4 2.2" posn="-21.1 -9 1.1"  valign="center" halign="center" style="BgsPlayerCard" substyle="BgCard"/>';
	$xmlscore .= '<quad sizen="4 2.2" posn="-7.7 -9 1.1"  valign="center" halign="center" style="BgRaceScore2" substyle="BgScores"/>';
	$xmlscore .= '<quad sizen="4 2.2" posn="-13.7 -9 1.1"  valign="center" halign="center" style="BgRaceScore2" substyle="BgScores"/>';
	$xmlscore .= '<quad sizen="2 2.2" posn="-16.7 -9 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleBlue"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-21.2 -8.2 1.5" sizen="6 3 2" scale="1" halign="center" text="$s$fffSets Won"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-13.5 -8.4 1.5" sizen="10 3 2" scale="1" halign="center" text="$s$0ff '.$SB.'/'.$CH.' "/>';
	$xmlscore .= '<quad sizen="2 2.2" posn="-10.7 -9 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleRed"/>';
	$xmlscore .= '<format textsize="1"/><label posn="-7.5 -8.4 1.5" sizen="10 3 2" scale="1"  halign="center" text="$s$0ff '.$SR.'/'.$CH.' "/>';
	$xmlscore .= '</frame>'; 
$xmlscore .= '</manialink>';
$aseco->client->query("SendDisplayManialinkPage", $xmlscore, 0, false);
}
}
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function create_widget_small_score($aseco) 
{
if ($aseco->server->gameinfo->mode == 2)
{
global $score, $xmlsscore, $xmlsscoreend, $showsmallrecords, $showendsmallrecords;

$SB = $score["SetBlue"];
$SR = $score["SetRed"];
$CH = $score["Challenges"];
$conf = simplexml_load_file('spykescore.xml');
$srposx = $conf->small_records->small_records_posx;
$srposy = $conf->small_records->small_records_posy;
$esrposx = $conf->small_records->end_small_records_posx;
$esrposy = $conf->small_records->end_small_records_posy;

if ($showsmallrecords == "false"){
$xmlsscore = '<manialink id="909005"></manialink>';
$aseco->client->addCall("SendDisplayManialinkPage", array($xmlsscore, 0, false)); }
else{

$xmlsscore = '<manialink id="909005">';
	$xmlsscore .= '<frame posn="'. $srposx .' '. $srposy .' 0">';
	$xmlsscore .= '<quad sizen="20 2.5" posn="-15 -9 1.1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlsscore .= '<quad sizen="4 1.5" posn="-7.7 -9 1.1"  valign="center" halign="center" style="BgRaceScore2" substyle="BgScores"/>';
	$xmlsscore .= '<quad sizen="4 1.5" posn="-13.7 -9 1.1"  valign="center" halign="center" style="BgRaceScore2" substyle="BgScores"/>';
	$xmlsscore .= '<quad sizen="2 1.5" posn="-16.7 -9 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleBlue"/>';
	$xmlsscore .= '<format textsize="1"/><label posn="-21.2 -8.2 1.5" sizen="6 3 2" scale="1" halign="center" text="$s$fffSets Won"/>';
	$xmlsscore .= '<format textsize="1"/><label posn="-13.5 -8.3 1.5" sizen="10 3 2" scale="1" halign="center" text="$s$0ff '.$SB.'/'.$CH.' "/>';
	$xmlsscore .= '<quad sizen="2 1.5" posn="-10.7 -9 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleRed"/>';
	$xmlsscore .= '<format textsize="1"/><label posn="-7.5 -8.3 1.5" sizen="10 3 2" scale="1"  halign="center" text="$s$0ff '.$SR.'/'.$CH.' "/>';
	$xmlsscore .= '</frame>';
$xmlsscore .= '</manialink>';
$aseco->client->addCall("SendDisplayManialinkPage", array($xmlsscore, 0, false));
}

if ($showendsmallrecords == "false"){
$xmlsscoreend = '<manialink id="909006"></manialink>';
$aseco->client->addCall("SendDisplayManialinkPage", array($xmlsscoreend, 0, false));}
else{
$xmlsscoreend = '<manialink id="909006">';
	$xmlsscoreend .= '<frame posn="'. $esrposx .' '. $esrposy .' 0">';
	$xmlsscoreend .= '<quad sizen="20 3.2" posn="-15 -9 1.1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton"/>';
	$xmlsscoreend .= '<quad sizen="4 2.2" posn="-7.7 -9 1.1"  valign="center" halign="center" style="BgRaceScore2" substyle="BgScores"/>';
	$xmlsscoreend .= '<quad sizen="4 2.2" posn="-13.7 -9 1.1"  valign="center" halign="center" style="BgRaceScore2" substyle="BgScores"/>';
	$xmlsscoreend .= '<quad sizen="2 2.2" posn="-16.7 -9 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleBlue"/>';
	$xmlsscoreend .= '<format textsize="1"/><label posn="-21.2 -8.2 1.5" sizen="6 3 2" scale="1" halign="center" text="$s$fffSets Won"/>';
	$xmlsscoreend .= '<format textsize="1"/><label posn="-13.5 -8.4 1.5" sizen="10 3 2" scale="1" halign="center" text="$s$0ff '.$SB.'/'.$CH.' "/>';
	$xmlsscoreend .= '<quad sizen="2 2.2" posn="-10.7 -9 1"  valign="center" halign="center" style="BgRaceScore2" substyle="HandleRed"/>';
	$xmlsscoreend .= '<format textsize="1"/><label posn="-7.5 -8.4 1.5" sizen="10 3 2" scale="1"  halign="center" text="$s$0ff '.$SR.'/'.$CH.' "/>';
	$xmlsscoreend .= '</frame>';
$xmlsscoreend .= '</manialink>';
$aseco->client->addCall("SendDisplayManialinkPage", array($xmlsscoreend, 0, false));
}
}
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function round_point_conf($aseco,$command) 
{
global $round_times, $round_finishes, $rpointsspyke;

$aseco->client->query('GetRoundCustomPoints');
$rpointsspyke = $aseco->client->getResponse();

$round_finishes = -1;
$round_times = array();
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function score_finish_clear($aseco,$command) //score_update_clear
{
global $score;
if($aseco->server->gameinfo->mode == 1 || $aseco->server->gameinfo->mode == 5)
		{
		$aseco->client->query('SetAllWarmUpDuration', 0);
		}
$CH = $score["Challenges"];
$SR = $score["SetRed"];
$SB = $score["SetBlue"];
$SBR = $SR+$SB;
if($CH==$SB || $CH==$SR || $CH<$SBR || $SBR==0 || $CH==$SBR)
	{
	$score["SetBlue"] = "0";
	$score["SetRed"] = "0";
	$score["RoundBlue"] = "0";
	$score["RoundRed"] = "0";
	$score["BluePoints"] = "0";
	$score["RedPoints"] = "0";
	}
	else
	{
	$score["RoundBlue"] = "0";
	$score["RoundRed"] = "0";
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function Spyke_Menu($aseco, $menu)
	{				
	$menu->addEntry('', 'mainhelpsep', false, 'Spyke Score', 'spykemenu');	
	$menu->addEntry('spykemenu', '', true, 'Time Attack', 'TAmenu');	
	$menu->addEntry('TAmenu', '', true, 'Server to TA', 'Server to TA', '/spk ta', null);
	$menu->addEntry('TAmenu', '', false, 'Time Conf', 'Taconf');
	$menu->addEntry('Taconf', '', true, '5 min', '5 min', '/spk ta5', null);
	$menu->addEntry('Taconf', '', true, '6 min', '6 min', '/spk ta6', null);
	$menu->addEntry('Taconf', '', true, '7 min', '7 min', '/spk ta7', null);
	$menu->addEntry('Taconf', '', true, '8 min', '8 min', '/spk ta8', null);
	$menu->addEntry('Taconf', '', true, '9 min', '9 min', '/spk ta9', null);
	$menu->addEntry('Taconf', '', true, '10 min', '10 min', '/spk ta10', null);
	$menu->addEntry('Taconf', '', true, '15 min', '15 min', '/spk ta15', null);
	$menu->addEntry('Taconf', '', true, '20 min', '20 min', '/spk ta20', null);
	$menu->addEntry('spykemenu', '', true, 'Match', 'Teammenu');	
	$menu->addEntry('Teammenu', '', true, 'Server to Match', 'Server to Match', '/spk match', null);		
	$menu->addEntry('Teammenu', '', false, 'Match Conf', 'matchmenu');
	$menu->addEntry('matchmenu', '', false, 'Team Conf', 'Team');
	$menu->addEntry('Team', '', true, 'Force Team', 'Force Team', '/spk force', null);
	$menu->addEntry('matchmenu', '', false, 'Rounds Conf', 'round');
	$menu->addEntry('round', '', true, '7 Rounds', '7 Rounds', '/spk r7', null);
	$menu->addEntry('round', '', true, '6 Rounds', '6 Rounds', '/spk r6', null);
	$menu->addEntry('round', '', true, '5 Rounds', '5 Rounds', '/spk r5', null);
	$menu->addEntry('round', '', true, '4 Rounds', '4 Rounds', '/spk r4', null);
	$menu->addEntry('round', '', true, '3 Rounds', '3 Rounds', '/spk r3', null);
	$menu->addEntry('round', '', true, '2 Rounds', '2 Rounds', '/spk r2', null);
	$menu->addEntry('round', '', true, '1 Round', '1 Round', '/spk r1', null);
	$menu->addEntry('matchmenu', '', false, 'Sets Conf', 'set');
	$menu->addEntry('set', '', true, '7 Sets', '7 Sets', '/spk c7', null);
	$menu->addEntry('set', '', true, '6 Sets', '6 Sets', '/spk c6', null);
	$menu->addEntry('set', '', true, '5 Sets', '5 Sets', '/spk c5', null);
	$menu->addEntry('set', '', true, '4 Sets', '4 Sets', '/spk c4', null);
	$menu->addEntry('set', '', true, '3 Sets', '3 Sets', '/spk c3', null);
	$menu->addEntry('set', '', true, '2 Sets', '2 Sets', '/spk c2', null);
	$menu->addEntry('set', '', true, '1 Set', '1 Set', '/spk c1', null);
	$menu->addEntry('matchmenu', '', false, 'Warm Up', 'wu');
	$menu->addEntry('wu', '', true, 'WU 2', 'wu 2', '/spk wu2', null);
	$menu->addEntry('wu', '', true, 'WU 1', 'wu 1', '/spk wu1', null);
	$menu->addEntry('wu', '', true, 'WU deactivate', 'wu 0', '/spk wu0',null);
	$menu->addEntry('matchmenu', '', false, 'System Points', 'NR');
	$menu->addEntry('NR', '', true, 'New rules ON', 'New rules ON', '/spk rules', null);
	$menu->addEntry('NR', '', true, 'Custom Points', 'Custom Points', '/spk norules', null);
	$menu->addEntry('matchmenu', '', false, 'Match Start', 'start');
	$menu->addEntry('start', '', true, 'Scores to 0', 'Scores to 0', '/spk start', null);
	$menu->addEntry('spykemenu', '', true, 'Round', 'Roundmenu');
	$menu->addEntry('Roundmenu', '', true, 'Server to Rounds', 'Server to Rounds', '/spk rounds', null);
	}	

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function spyke_right($aseco, $author) 
{
global $info, $rights, $spyke_conf;
$conf = simplexml_load_file('spykescore.xml');
$rights = $conf->perm->rights;
if ($rights == "operator")
{
if ($aseco->isMasterAdmin($author))
{return true;
}elseif ($aseco->isAdmin($author))
{return true;
}elseif ($aseco->isOperator($author))
{return true;}
}elseif ($rights == "admin")
{
if ($aseco->isMasterAdmin($author))
{return true;
}elseif ($aseco->isAdmin($author))
{return true;
}else
{return false;}
}
elseif ($rights == "masteradmin")
{
if ($aseco->isMasterAdmin($author))
{return true;
}else
{return false;}
}
}	

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function spyke_forceteam($aseco, $answer)
{
global $admin;
		
if ($answer[2] >= 16201 && $answer[2] <= 16400) {
$target = $admin->playerlist[$answer[2]-16201]['login'];
$player = $aseco->getPlayerParam($admin, $target);
if ($player->isspectator != 0){
$aseco->client->query('ForceSpectator', $player->login, 2);}
$aseco->client->query('ForceSpectator', $player->login, 0);
$team = 0; 
$aseco->client->query('ForcePlayerTeam', $target, $team);
$aseco->console('player {1} clicked command "/blue"', $target);
$message = formatText('{#server}>> {#admin}{1}$z$s {#highlite}{2}$z$s{#admin} forces {#highlite}{3}$z$s{#admin} into $00fBlue{#admin} team !',
								                      $chattitle, $admin->nickname, str_ireplace('$w', '', $target));
								$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));	
}elseif($answer[2] >= 16401 && $answer[2] <= 16600) {
$target = $admin->playerlist[$answer[2]-16401]['login'];
$player = $aseco->getPlayerParam($admin, $target);
if ($player->isspectator != 0){
$aseco->client->query('ForceSpectator', $player->login, 2);
$aseco->client->query('ForceSpectator', $player->login, 0);
}
$team = 1; 
$aseco->client->query('ForcePlayerTeam', $target, $team);
$aseco->console('player {1} clicked command "/red"', $target);
$message = formatText('{#server}>> {#admin}{1}$z$s {#highlite}{2}$z$s{#admin} forces {#highlite}{3}$z$s{#admin} into $f00Red{#admin} team !',
								                      $chattitle, $admin->nickname, str_ireplace('$w', '', $target));
								$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
}else {}	

}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function chat_spk($aseco, $info)  
{
if ($aseco->server->gameinfo->mode == 2 || $aseco->server->gameinfo->mode == 1 || $aseco->server->gameinfo->mode == 5 || $aseco->server->gameinfo->mode == 0)
{
global $pointslimit, $score, $author, $playerlist, $admin, $player;
$author = $info["author"]->login;
if (spyke_right($aseco, $info["author"])) 
{
$command["params"] = $info["params"];
$admin = $info['author'];
$login = $admin->login;
$arglist = explode(' ', $command['params'], 2);
if (!isset($arglist[1])) $arglist[1] = '';
$command['params'] = explode(' ', preg_replace('/ +/', ' ', $command['params']));
if (!isset($command['params'][1])) $command['params'][1] = '';

if ($command['params'][0] == 'r7') 
{
$pointslimit=7;
$aseco->addCall('SetTeamPointsLimit', array($pointslimit));
$message = formatText('{#server}>>{#highlite} $sMatch en $28b7 $6c0rounds $fffpar $6c0challenge $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->addCall('ForceEndRound');
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'r6') 
{
$pointslimit=6;
$aseco->addCall('SetTeamPointsLimit', array($pointslimit));
$message = formatText('{#server}>>{#highlite} $sMatch en $28b6 $6c0rounds $fffpar $6c0challenge $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->addCall('ForceEndRound');
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'r5') 
{
$pointslimit=5;
$aseco->addCall('SetTeamPointsLimit', array($pointslimit));
$message = formatText('{#server}>>{#highlite} $sMatch en $28b5 $6c0rounds $fffpar $6c0challenge $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->addCall('ForceEndRound');
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'r4')
{
$pointslimit=4;
$aseco->addCall('SetTeamPointsLimit', array($pointslimit));
$message = formatText('{#server}>>{#highlite} $sMatch en $28b4 $6c0rounds $fffpar $6c0challenge $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->addCall('ForceEndRound');
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'r3') 
{
$pointslimit=3;
$aseco->addCall('SetTeamPointsLimit', array($pointslimit));
$message = formatText('{#server}>>{#highlite} $sMatch en $28b3 $6c0rounds $fffpar $6c0challenge $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->addCall('ForceEndRound');
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'r2') 
{
$pointslimit=2;
$aseco->addCall('SetTeamPointsLimit', array($pointslimit));
$message = formatText('{#server}>>{#highlite} $sMatch en $28b2 $6c0rounds $fffpar $6c0challenge $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->addCall('ForceEndRound');
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'r1') 
{
$pointslimit=1;
$aseco->addCall('SetTeamPointsLimit', array($pointslimit));
$message = formatText('{#server}>>{#highlite} $sMatch en $28b1 $6c0rounds $fffpar $6c0challenge $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->addCall('ForceEndRound');
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'wu0') 
{
$aseco->client->query('SetAllWarmUpDuration', 0);
$message = formatText('{#server}>>{#highlite} $s$6c0Warm up $i$fffdesactive $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'wu1') 
{
$message = formatText('{#server}>>{#highlite} $s$6c0Warm up $fffa $28b1 $i$fff(NextChallenge svp ! )');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->client->query('SetAllWarmUpDuration', 1);
}
elseif ($command['params'][0] == 'wu2') 
{
$message = formatText('{#server}>>{#highlite} $s$6c0Warm up $fffa $28b2 $i$fff(NextChallenge svp ! )');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->client->query('SetAllWarmUpDuration', 2);
}
elseif ($command['params'][0] == 'ta') 
{
$message = formatText('{#server}>>{#highlite} $sServer en mode $28bTA $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->client->query('SetAllWarmUpDuration', 0);
$aseco->client->query('SetGameMode', 1);
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'match') 
{

$message = formatText('{#server}>>{#highlite} $sServer en mode $28bmatch $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->client->query('SetAllWarmUpDuration', 2);
$aseco->client->query('SetGameMode', 2);
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'rounds') 
{
$message = formatText('{#server}>>{#highlite} $sServer en mode $28brounds $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->client->query('SetAllWarmUpDuration', 2);
$aseco->client->query('SetGameMode', 0);
$aseco->addCall('NextChallenge');
}

elseif ($command['params'][0] == 'rules') 
{
$aseco->addcall('SetUseNewRulesTeam', array(TRUE));
$aseco->addCall('NextChallenge');
$message = formatText('{#server}>>{#highlite} $sPoints $6c0Max $fff= $28bnombre $fffde $6c0joueurs $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
}
elseif ($command['params'][0] == 'norules') 
{
$aseco->addcall('SetUseNewRulesTeam', array(FALSE));
$aseco->addCall('NextChallenge');
$message = formatText('{#server}>>{#highlite} $sPoints $6c0System $fff= $28bCustom $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
}
elseif ($command['params'][0] == 'start') 
{
$score["SetBlue"] ="0";
$score["SetRed"] = "0";
$score["RoundBlue"] = "0";
$score["RoundRed"] = "0";
$score["EndRoundBlue"] = "0";
$score["EndRoundRed"] = "0";
$score["BluePoints"] = "0";
$score["RedPoints"] = "0";
$i=0;
$aseco->addCall('NextChallenge');
$message = formatText('{#server}>>{#highlite}  $sDebut de $6c0Match $28bScores a 0 $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
}
elseif ($command['params'][0] == 'ta5') 
{
$message = formatText('{#server}>>{#highlite} $smode $28bTA 5 min $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->client->query('SetAllWarmUpDuration', 0);
$aseco->client->query('SetGameMode', 1);
$aseco->client->query('SetTimeAttackLimit', 300000);
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'ta6') 
{
$message = formatText('{#server}>>{#highlite} $smode $28bTA 6 min $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->client->query('SetAllWarmUpDuration', 0);
$aseco->client->query('SetGameMode', 1);
$aseco->client->query('SetTimeAttackLimit', 360000);
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'ta7') 
{
$message = formatText('{#server}>>{#highlite} $smode $28bTA 7 min $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->client->query('SetAllWarmUpDuration', 0);
$aseco->client->query('SetGameMode', 1);
$aseco->client->query('SetTimeAttackLimit', 420000);
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'ta8') 
{
$message = formatText('{#server}>>{#highlite} $smode $28bTA 8 min $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->client->query('SetAllWarmUpDuration', 0);
$aseco->client->query('SetGameMode', 1);
$aseco->client->query('SetTimeAttackLimit', 480000);
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'ta9') 
{
$message = formatText('{#server}>>{#highlite} $smode $28bTA 9 min $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->client->query('SetAllWarmUpDuration', 0);
$aseco->client->query('SetGameMode', 1);
$aseco->client->query('SetTimeAttackLimit', 540000);
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'ta10') 
{
$message = formatText('{#server}>>{#highlite} $smode $28bTA 10 min $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->client->query('SetAllWarmUpDuration', 0);
$aseco->client->query('SetGameMode', 1);
$aseco->client->query('SetTimeAttackLimit', 600000);
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'ta15') 
{
$message = formatText('{#server}>>{#highlite} $smode $28bTA 10 min $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->client->query('SetAllWarmUpDuration', 0);
$aseco->client->query('SetGameMode', 1);
$aseco->client->query('SetTimeAttackLimit', 900000);
$aseco->addCall('NextChallenge');
}
elseif ($command['params'][0] == 'ta20') 
{
$message = formatText('{#server}>>{#highlite} $smode $28bTA 10 min $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
$aseco->client->query('SetAllWarmUpDuration', 0);
$aseco->client->query('SetGameMode', 1);
$aseco->client->query('SetTimeAttackLimit', 1200000);
$aseco->addCall('NextChallenge');
}

elseif ($command['params'][0] == 'c1') 
{
$score["Challenges"]="1";
$aseco->addCall('NextChallenge');
$message = formatText('{#server}>>{#highlite}  $sMatch en $28b1 $6c0Challenge $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
}
elseif ($command['params'][0] == 'c2') 
{
$score["Challenges"]="2";
$aseco->addCall('NextChallenge');
$message = formatText('{#server}>>{#highlite}  $sMatch en $28b2 $6c0Challenges $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
}
elseif ($command['params'][0] == 'c3') 
{
$score["Challenges"]="3";
$aseco->addCall('NextChallenge');
$message = formatText('{#server}>>{#highlite}  $sMatch en $28b3 $6c0Challenges $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
}
elseif ($command['params'][0] == 'c4') 
{
$score["Challenges"]="4";
$aseco->addCall('NextChallenge');
$message = formatText('{#server}>>{#highlite}  $sMatch en $28b4 $6c0Challenges $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
}
elseif ($command['params'][0] == 'c5') 
{
$score["Challenges"]="5";
$aseco->addCall('NextChallenge');
$message = formatText('{#server}>>{#highlite}  $sMatch en $28b5 $6c0Challenges $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
}
elseif ($command['params'][0] == 'c6') 
{
$score["Challenges"]="6";
$aseco->addCall('NextChallenge');
$message = formatText('{#server}>>{#highlite}  $sMatch en $28b6 $6c0Challenges $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
}
elseif ($command['params'][0] == 'c7') 
{
$score["Challenges"]="7";
$aseco->addCall('NextChallenge');
$message = formatText('{#server}>>{#highlite}  $sMatch en $28b7 $6c0Challenges $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
}
elseif ($command['params'][0] == 'c8') 
{
$score["Challenges"]="8";
$aseco->addCall('NextChallenge');
$message = formatText('{#server}>>{#highlite}  $s$6c0Match en $28b8 $6c0Challenges $i$fff(NextChallenge Autorestarted)');
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
}
elseif ($command['params'][0] == 'force') {
		$admin->playerlist = array();
		$admin->msgs = array();

		$admin->panels['plyparam'] = $command['params'][1];
		$onlineonly = "true";		
		$aseco->client->resetError();
		$onlinelist = array();
		$onlinelist = $aseco->server->players->player_list;
		$aseco->client->query('GetPlayerList', 300, 0);
		$players = $aseco->client->getResponse();
		if ($aseco->client->isError()) {
			trigger_error('[' . $aseco->client->getErrorCode() . '] ' . $aseco->client->getErrorMessage(), E_USER_WARNING);
		} else {
			foreach ($players as $pl)
				$onlinelist[$pl['Login']] = array('login' => $pl['Login'],
				                                  'nick' => $pl['NickName'],
											'team' => $pl['TeamId'],
											'spec' => false);
		}

		if ($onlineonly) {
			$playerlist = $onlinelist;
		}
		if (!empty($playerlist)) {
			if ($aseco->server->getGame() == 'TMN') {
				$head = ' Online Players TMN On This Server:' . LF .
				         'Id     {#nick}Nick $g/{#login} Login' . LF;
				$msg = '';
				$pid = 1;
				$lines = 0;
				$admin->msgs[0] = 1;
				foreach ($playerlist as $pl) {
					$plarr = array();
					$plarr['login'] = $pl['login'];
					$admin->playerlist[] = $plarr;

					$msg .= '$g' . str_pad($pid, 2, '0', STR_PAD_LEFT) . '.   {#black}'
					        . str_ireplace('$w', '', $pl['nick']) . '$z / '
					        . ($aseco->isAnyAdminL($pl['login']) ? '{#logina}' : '{#login}' )
					        . $pl['login'] . LF;
					$pid++;
					$lines++;
					if ($lines > 9) {
						$admin->msgs[] = $aseco->formatColors($head . $msg);
						$lines = 0;
						$msg = '';
					}
				}
				if ($msg != '')
					$admin->msgs[] = $aseco->formatColors($head . $msg);

				
				if (count($admin->msgs) == 2) {
					$aseco->client->query('SendDisplayServerMessageToLogin', $login, $admin->msgs[1], 'OK', '', 0);
				} elseif (count($admin->msgs) > 2) {
					$aseco->client->query('SendDisplayServerMessageToLogin', $login, $admin->msgs[1], 'Close', 'Next', 0);
				} else {  // == 1
					$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors('{#server}> {#error}No player(s) found!'), $login);
				}

			} elseif ($aseco->server->getGame() == 'TMF') {
				$head = ' Online Players TMF On This Server:';
				$msg = array();
				$msg[] = array('Id', '{#nick}Nick $g/{#login} Login', 'Force Blue', 'Force Red');
				$pid = 1;
				$lines = 0;
				$admin->msgs[0] = array(1, $head, array(1.49, 0.15, 0.5, 0.2, 0.2), array('Icons128x128_1', 'Buddies'));

				foreach ($playerlist as $lg => $pl) {
					$plarr = array();
					$plarr['login'] = $lg;
					$admin->playerlist[] = $plarr;

					
					$ply = '{#black}' . str_ireplace('$w', '', $pl['nick']) . '$z / '
					       . ($aseco->isAnyAdminL($pl['login']) ? '{#logina}' : '{#login}' )
					       . $pl['login'];
					
					$frc = '$09f    Blue';
					$off = '$f00    Red';
					$spc = '$09c    Spec';
										
					if ($pid <= 200) {
						if ($pl['team']==1)
						$frc = array($frc, $pid+16200);
						if ($pl['team']==0)
						$off = array($off, $pid+16400);
						if ($pl['spec']!=1 && $pl['team']!=1 && $pl['team']!=0)
							{
							$frc = array($frc, $pid+16200);
							$off = array($off, $pid+16400);
							}
						}
					$msg[] = array(str_pad($pid, 2, '0', STR_PAD_LEFT) . '.', $ply, $frc, $off);
					$pid++;
					$lines++;
					if ($lines > 14) {
						$admin->msgs[] = $msg;
						$lines = 0;
						$msg = array();
						$msg[] = array('Id', '{#nick}Nick $g/{#login} Login', 'Force Blue', 'Force Red');
					}
			}	
				if (count($msg) > 1)
					$admin->msgs[] = $msg;

				if (count($admin->msgs) > 1) {
					display_manialink_multi($admin);
				} else {  // == 1
					$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors('{#server}> {#error}No player(s) found!'), $login);
				}
			}
		
	}else {
			$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors('{#server}> {#error}No player(s) found!'), $login);
		}
	}
	
}

else{
$aseco->addCall('ChatSendServerMessageToLogin', array('$f00>> [Spyke] sorry, you do not have permission.', $author));
}
}

}

?>